
extern "C" {
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <limits.h>
}
#include "tempfile.h"

// Return a file pointer to a temporary file
FILE *create_tempfile(const char *mode, char *filename)
{
	char tempfile[PATH_MAX];
	const char *tmp = getenv("TMPDIR");
	if ( filename == NULL ) {
		filename = tempfile;
	}
	sprintf(filename, "%s/mmrXXXXXX", tmp ? tmp : "/tmp");

	int fd = mkstemp(filename);
	if ( filename == tempfile ) {
		unlink(filename);
	}
	return fdopen(fd, mode);
}
